% equalizer();
% Graphical interface an equalizer
% equalizer.m
% orig. author: Robert Stevenson
% modified:     Nicholas Kottenstette
% date:         11/9/2004

% Initialize figure
left=50;
bottom=300;
width=450;
height=400;
fh = figure('Position',[left bottom width height],...
            'Resize','off',...
            'NumberTitle','off',...
            'Name','8-Band Equalizer');
fhp = figure('Name','Equalizer Analysis');
pos = get(fhp,'Position');
set(fhp,'Position',[left+width+10 bottom pos(3:4)]);
set(fh,'CloseRequestFcn','windows_close();');
clf(fh);
clf(fhp);

f = [ 0 0 0 0 0 0 0 0 ];
x=[];
Fs=44100;
bits=16;
y=[0];

%%%%%%%%%%%%%% Control buttons %%%%%%%%%%%

but_load = uicontrol(fh,...
        'Style', 'push',...
	'String', 'Load',...
        'Position', [10 10 100 25],...
	'callback','[x,Fs,bits]=load_audio_file(fhp,1);');

but_process = uicontrol(fh,...
        'Style', 'push',...
	'String', 'Process',...
        'Position', [120 10 100 25],...
	'callback','[y,h,G]=dsp_eq(f,x,256,Fs,fhp,2);');

but_play = uicontrol(fh,...
        'Style', 'push',...
	'String', 'Play',...
        'Position', [230 10 100 25],...
	'callback','eq_play(x,y,Fs,bits);');

but_save = uicontrol(fh,...
        'Style', 'push',...
	'String', 'Save',...
        'Position', [340 10 100 25],...
	'callback','save_audio(y,Fs,bits);');

%%%%%%%%%%%%%% Band 1 %%%%%%%%%%%


sli_band1 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [50 60 20 300],...
	'callback','f=[get(sli_band1,''Value'') f(2:8)];');
txt_band1_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[25 370 50 20],...
	'String','150Hz');
txt_band1_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[20 70 30 20],...
	'String','-10');
txt_band1_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[20 135 30 20],...
	'String',' -5');
txt_band1_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[20 200 30 20],...
	'String','  0');
txt_band1_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[20 265 30 20],...
	'String',' +5');
txt_band1_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[20 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 2 %%%%%%%%%%%

sli_band2 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [100 60 20 300],...
	'callback','f=[f(1) get(sli_band2,''Value'') f(3:8)];');
txt_band2_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[75 370 50 20],...
	'String','300Hz');
txt_band2_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[70 70 30 20],...
	'String','-10');
txt_band2_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[70 135 30 20],...
	'String',' -5');
txt_band2_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[70 200 30 20],...
	'String','  0');
txt_band2_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[70 265 30 20],...
	'String',' +5');
txt_band2_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[70 330 30 20],...
	'String','+10');
%%%%%%%%%%%%%% Band 3 %%%%%%%%%%%

sli_band3 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [150 60 20 300],...
	'callback','f=[f(1:2) get(sli_band3,''Value'') f(4:8)];');
txt_band3_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[125 370 50 20],...
	'String','600Hz');
txt_band3_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[120 70 30 20],...
	'String','-10');
txt_band3_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[120 135 30 20],...
	'String',' -5');
txt_band3_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[120 200 30 20],...
	'String','  0');
txt_band3_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[120 265 30 20],...
	'String',' +5');
txt_band3_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[120 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 4 %%%%%%%%%%%

sli_band4 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [200 60 20 300],...
	'callback','f=[f(1:3) get(sli_band4,''Value'') f(5:8)];');
txt_band4_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[175 370 50 20],...
	'String','1.2kHz');
txt_band4_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[170 70 30 20],...
	'String','-10');
txt_band4_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[170 135 30 20],...
	'String',' -5');
txt_band4_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[170 200 30 20],...
	'String','  0');
txt_band4_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[170 265 30 20],...
	'String',' +5');
txt_band4_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[170 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 5 %%%%%%%%%%%

sli_band5 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [250 60 20 300],...
	'callback','f=[f(1:4) get(sli_band5,''Value'') f(6:8)];');
txt_band5_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[225 370 50 20],...
	'String','2.4kHz');
txt_band5_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[220 70 30 20],...
	'String','-10');
txt_band5_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[220 135 30 20],...
	'String',' -5');
txt_band5_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[220 200 30 20],...
	'String','  0');
txt_band5_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[220 265 30 20],...
	'String',' +5');
txt_band5_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[220 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 6 %%%%%%%%%%%

sli_band6 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [300 60 20 300],...
	'callback','f=[f(1:5) get(sli_band6,''Value'') f(7:8)];');
txt_band6_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[275 370 50 20],...
	'String','4.8kHz');
txt_band6_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[270 70 30 20],...
	'String','-10');
txt_band6_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[270 135 30 20],...
	'String',' -5');
txt_band6_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[270 200 30 20],...
	'String','  0');
txt_band6_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[270 265 30 20],...
	'String',' +5');
txt_band6_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[270 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 7 %%%%%%%%%%%

sli_band7 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [350 60 20 300],...
	'callback','f=[f(1:6) get(sli_band7,''Value'') f(8)];');
txt_band7_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[325 370 50 20],...
	'String','9.2kHz');
txt_band7_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[320 70 30 20],...
	'String','-10');
txt_band7_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[320 135 30 20],...
	'String',' -5');
txt_band7_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[320 200 30 20],...
	'String','  0');
txt_band7_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[320 265 30 20],...
	'String',' +5');
txt_band7_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[320 330 30 20],...
	'String','+10');

%%%%%%%%%%%%%% Band 8 %%%%%%%%%%%

sli_band8 = uicontrol(fh,...
        'Style', 'slider',...
	'Min',-10,...
 	'Max', 10,...
	'Value', 0,...
        'Position', [400 60 20 300],...
	'callback','f=[f(1:7) get(sli_band8,''Value'')];');
txt_band8_title = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','center',...
	'Style','text',...
	'Pos',[375 370 50 20],...
	'String','18.4kHz');
txt_band8_lab1 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[370 70 30 20],...
	'String','-10');
txt_band8_lab2 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[370 135 30 20],...
	'String',' -5');
txt_band8_lab3 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[370 200 30 20],...
	'String','  0');
txt_band8_lab4 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[370 265 30 20],...
	'String',' +5');
txt_band8_lab5 = uicontrol(fh,...
	'BackgroundColor',[0 0 0],...
	'ForegroundColor',[1 1 1],...
	'HorizontalAlignment','right',...
	'Style','text',...
	'Pos',[370 330 30 20],...
	'String','+10');

  