function [y,Fs,bits] = load_audio_file(fhp,in)
% [y,Fs,bits] = load_audio_file(fhp,in)
% inputs:
% fhp -> figure handle for plotting
% in  -> index for 2x2 subplot in fhp
% outputs:
% y    -> =/-1.0 normolized audio-file data for a single channel
% Fs   -> Sampling frequency Hz of audio-data file
% bits -> bits per sample for audio file
% load_audio_files.m
% author: Nicholas Kottenstette
% date:   11/9/2004
  [filename, pathname]=uigetfile('*.au','Pick an au-file');
  if isequal(filename,0) | isequal(pathname,0)
    disp('User Pressed cancel');
  else
    fn = fullfile(pathname, filename);
    disp(['User selected ', fn]);
  end
  siz=auread(fn,'size');
  samp = siz(1);
  channels = siz(2);
  [y,Fs,bits]=auread(fn,min(samp,44100*channels*5.0));
  [samp,channels] = size(y);
  if channels == 2
    y = y(:,1)' + y(:,2)';
  else
    y = y(:,1)';
  end
  spec_plot(y,Fs,fhp,'Input Spectrogram',in);