function save_audio(y,Fs,bits)
% save_audio(y,Fs,bits)
% save y to user specified file in Sun .au format
% inputs:
% y    -> normalized audio data vector (+/- 1.0 => +/- full_scale)
% Fs   -> sampling frequency Hz
% bits -> bits per sample
% outputs:
% none
% save_audio.m
% author: Nicholas Kottenstette
% date:   11/9/2004
  [filename, pathname] = uiputfile( ...
      {'*.au', 'All au-files (*.au)'},...
       'Save as');
  if isequal(filename,0) | isequal(pathname,0)
    disp('User pressed cancel')
    return;
  else
    fn = fullfile(pathname, filename);
    disp(['User selected ', fn])
  end
  auwrite(y,Fs,bits,'linear',fn);