function spec_plot(x,Fs,fhp,ti,in)
% spec_plot(x,Fs,fhp,ti,in)
% Plot and label audio spectrogram to guide equalizer selection
% inputs:
% x   -> data to generate spectrogram
% Fs  -> sampling frequency of data
% fhp -> figure handle for plotting
% ti  -> title for plot
% in  -> index for 2x2 subplot in fhp
% outputs:
% none
% author: Nicholas Kottenstette
% date:   11/9/2004
  dT = .15;    %Desire to window every .15  seconds of data
  nfft = 2^13; %.1858 seconds of 44.1 kHz data
  nwin  = min(ceil(dT*Fs),nfft);
  nover = ceil(.05*nwin);
  %[B,f,t]=dsp_specgram(x,nfft,Fs,nwin,nover);
  [B,f,t]=specgram(x,nfft,Fs,nwin,nover);
  figure(fhp);subplot(2,2,in);mesh(t,f,20*log10(abs(B)+1e-6));view(2); ...
      axis('tight');
  xlabel('time (s)');ylabel('freq (Hz)');title(ti);grid;
